// syringe.js v0.5.6. Copyright (c) 2013 Michael Holt, holt.org. Distributed under the MIT License
(function(){"use strict";var root=this,store={},hasProp={}.hasOwnProperty,slice=[].slice;var utils={getObj:function(str,ctx,sep){return str.split(sep||".").filter(function(num){return num.length}).reduce(function(prev,curr,index,list){if(prev){return prev[list[index]]}},ctx||this)},setObj:function(str,ctx,sep){return str.split(sep||".").reduce(function(prev,curr){return prev[curr]?prev[curr]:prev[curr]={}},ctx||this)},bindArgs:function(){var args=slice.call(arguments),fn=this;return function(){return fn.apply(this,args.concat(slice.call(arguments)))}},makeId:function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(b){var a=16*Math.random()|0;return("x"===b?a:a&3|8).toString(16)})},getType:function(obj,istype){var ret="Undefined",types=["Window","HTMLDocument","Global","Document"];if(obj){ret={}.toString.call(obj).match(/\s([a-z|A-Z]+)/)[1];types=types.some(function(item){return item.toLowerCase()===ret.toLowerCase()});ret=types?"Object":ret}else{if(obj===null){ret="Null"}else if(obj===false){ret="Boolean"}else if(typeof obj==="string"){ret="String"}else if(obj===0){ret="Number"}else if(isNaN(obj)&&typeof obj==="number"){ret="NaN"}}if(typeof istype==="string"){return istype.toLowerCase()===ret.toLowerCase()}else{return ret}},matchArgs:function(args,istype){istype=istype||[];args=[].slice.call(args);if(!istype.length){return args.map(function(item){return utils.getType(item)})}else if(istype.length===args.length){return args.reduce(function(prev,curr,idx){if(!prev&&utils.getType(istype[idx],"string")){return false}return utils.getType(curr,istype[idx])},true)}else{return false}},getReg:function(arr,id){var reg=store[id].registry;return arr.map(function(item){switch(item){case"":return undefined;case"*":return reg;case"this":return this;default:return utils.getObj(item,reg,store[id].sep)}},this)},getData:function(url,callback){var xhr;if(!utils.getType(XMLHttpRequest,"undefined")){xhr=new XMLHttpRequest}else{["MSXML2.XmlHttp.5.0","MSXML2.XmlHttp.4.0","MSXML2.XmlHttp.3.0","MSXML2.XmlHttp.2.0","Microsoft.XmlHttp"].forEach(function(item){try{xhr=new window.ActiveXObject(item);return}catch(e){}})}xhr.onreadystatechange=function(){if(xhr.readyState<4){return}if(xhr.status!==200){callback(null)}else if(xhr.readyState===4){callback(xhr)}};xhr.open("GET",url,true);xhr.setRequestHeader("Accept","application/json, text/javascript, */*; q=0.01");xhr.setRequestHeader("Content-Type","application/json; charset=utf-8");xhr.send("")},isEmpty:function(obj){for(var key in obj){if(hasProp.call(obj,key)){return false}}return true},fetch:function(arr,props,ctx){props=props||{};props.success=props.success||false;props.xss=props.xss||false;var self=this,count=0,url="";var isLocalURL=function(url){var regexp=new RegExp("//"+location.host+"($|/)");return"http"===url.substring(0,4)?regexp.test(url):true};var stack=function(xhr){if(xhr&&xhr.responseText){var data=JSON.parse(xhr.responseText);if(data){self.add(arr[count].bind,data)}}if(++count===arr.length){if(utils.getType(props.success,"function")){props.success.call(self,ctx||self)}}};arr.forEach(function(item){if(isLocalURL(url=item.path)||props.xss===true){utils.getData(item.path,stack)}})},run:function(arr,fn,syr){var args=slice.call(arguments),props,match,ins,res;args.splice(2,1);match=store[syr.id].cabinet.filter(function(item){return item.fn===fn})[0];fn=match?match.fn:fn;props=utils.getReg.apply(syr,[arr,syr.id]).concat(args.slice(2,args.length));arr.forEach(function(item,idx){if(utils.getType(item,"string")&&item.indexOf("global:")===0){props[idx]=utils.getObj(item.slice(7,item.length),root,".")}});if(!utils.isEmpty(fn.prototype)){ins=Object.create(fn.prototype);res=fn.apply(ins,props);return utils.getType(res,"object")?res:ins}else{return fn.apply(this,props)}}};var Syringe=function(props){store[this.id=utils.makeId()]={cabinet:[],registry:props&&utils.getType(props,"object")?props:{},separator:"."}};var proto=Syringe.prototype={separator:function(val){return utils.getType(val,"string")&&1===val.replace(/[?a-zA-Z\d]|\s/g,"").length?(store[this.id].separator=val,this):false},add:function(name,value,bindings){var reg=store[this.id].registry,sep=store[this.id].separator;if(utils.getType(name,"object")){Object.keys(name).forEach(function(key){this.add.apply(this,[key,name[key]])},this);return this}if(!utils.getType(name,"string")){throw new Error("Name must be a string!")}name=name.trim();if(name.indexOf("global:")===0){throw new Error("You can't add a key with this prefix!")}if(utils.getObj(name,reg,sep)){throw new Error('Key "'+name+'" already exists in the map; use .remove() to unregister it first!')}else{if(utils.getType(value,"function")&&bindings){value=this.on(bindings,value)}var arr=name.split(sep),str=arr.length>1?arr.pop():false;if(str){utils.setObj(arr.join(sep),reg,sep)[str]=value}else{reg[arr.toString()]=value}}return this},remove:function(name){if(utils.getType(name,"array")){name.forEach(function(item){if(utils.getType(item,"string")){this.remove(item)}},this);return}if(utils.getType(name,"string")){name=name.trim();var reg=store[this.id].registry,sep=store[this.id].separator,snm=name.trim().split(sep),lst=snm.pop(),nrg={},obj={};snm=snm.join(sep);obj=snm?utils.getObj(snm,reg,sep):reg;if(utils.getType(obj,"object")){name=lst||snm;Object.keys(obj).forEach(function(key){if(key!==name){nrg[key]=obj[key]}});if(snm){this.set(snm,nrg)}else{store[this.id].registry=nrg}}}return this},on:function(){var cab=store[this.id].cabinet,args=slice.call(arguments),ctx=root,obj={args:args},gtp=utils.getType,mtc=utils.matchArgs,anon,anonctx,named,namedctx,map;var bindArgsOnly=utils.bindArgs.bind(utils.run);var namedFuncFactory=function(name,fn,target){var sep=store[this.id].separator,arr=name.split(sep),str=arr.length>1?arr.pop():false;target=gtp(target,"object")?target:root;if(str){utils.setObj(arr.join(sep),target,sep)[str]=fn}else{target[arr.join(sep)]=fn}}.bind(this);map=mtc(args,["object"]);anon=mtc(args,["array","function"]);anonctx=mtc(args,["array","function","object"]);named=mtc(args,["string","array","function"]);namedctx=mtc(args,["string","array","function","object"]);if(anon||anonctx||named||namedctx){var n=named||namedctx?1:0;obj.fn=args[n+1];obj.ctx=anonctx?args[n+2]:ctx;if(anon||named){obj.bind=bindArgsOnly(args[n+0],args[n+1],this)}else if(anonctx||namedctx){obj.bind=utils.run.bind(args[n+2],args[n+0],args[n+1],this)}cab.push(obj);if(n){namedFuncFactory(args[0],obj.bind,ctx);return this}else{return obj.bind}}else if(map){var props=gtp(args[0],"object")?args[0]:{},name=gtp(props.name,"string")?props.name:false,bindings=gtp(props.bindings,"array")?props.bindings:false,fn=gtp(props.fn,"function")?props.fn:false,target=gtp(props.target,"object")?props.target:false,add=gtp(props.target,"object")?props.add:false;ctx=gtp(props.ctx,"object")?props.ctx:ctx;if(bindings.length&&fn){obj.fn=fn;obj.ctx=ctx;if(props.ctx){obj.bind=utils.run.bind(props.ctx,bindings,fn,this)}else{obj.bind=bindArgsOnly(bindings,fn,this)}cab.push(obj);if(props.add&&gtp(props.add.name,"string")){if(gtp(props.add.bindings,"array")){this.add(props.add.name,obj.bind,props.add.bindings)}else{this.add(props.add.name,obj.bind)}}if(name){namedFuncFactory(name,obj.bind,target);return this}else{return obj.bind}}}return this},exec:function(name,args,ctx){ctx=ctx||this;var fn=this.get(name);var _fn=store[this.id].cabinet.filter(function(item){return item.bind===fn})[0];args=utils.getType(args,"array")?args:[args];if(utils.getType(name,"string")&&utils.getType(fn,"function")){if(_fn){fn=_fn?_fn.fn:fn;return utils.run.apply(ctx,[_fn.args[0],fn,this].concat(args))}return fn.apply(ctx,args)}return false},get:function(name){var reg=store[this.id].registry;if(utils.getType(name,"string")){var obj=utils.getObj(name,reg,store[this.id].separator);if(!utils.getType(obj,"undefined")){return obj}return false}return reg},set:function(name,value,bindings){var reg=store[this.id].registry,sep=store[this.id].separator,arr=name.split(sep),str=arr.length>1?arr.pop():false,prn;if(utils.getObj(name,reg,sep)===undefined){prn=utils.getObj(arr.join(sep),reg,sep);if(str){if(prn&&!hasProp.call(prn,str)||!prn){throw new Error('Key "'+name+'" does not exist in the map!')}}else if(!hasProp.call(reg,arr.toString())){throw new Error('Key "'+name+'" does not exist in the map!')}}if(utils.getType(value,"function")&&bindings){value=this.on(bindings,value)}if(str){utils.setObj(arr.join(sep),reg,sep)[str]=value}else{reg[arr.toString()]=value}return this},wrap:function(fn,wrapper,ctx){ctx=ctx||this;var match=store[this.id].cabinet.filter(function(item){return item.bind===fn})[0];if(match){return function(){var args=slice.call(arguments);return wrapper.apply(ctx,[function(){args=arguments.length?arguments:args;return match.bind.apply(ctx,args)}].concat(args))}}return false},copy:function(bindings,fn,ctx){ctx=ctx||this;var cab=store[this.id].cabinet;var match=cab.filter(function(item){return item.bind===fn})[0];if(match){var obj={fn:fn,ctx:slice.call(arguments)[0],bind:utils.run.bind(match.ctx,bindings,match.fn,this)};cab.push(obj);return obj.bind}return false},create:function(props){return new Syringe(props)}};proto.mixin=function(obj){if(utils.getType(obj,"object")){Object.keys(obj).forEach(function(key){if(utils.getType(obj[key],"function")){proto[key]=obj[key]}});return this}return false};proto.bind=proto.on;proto.register=proto.add;proto.unregister=proto.remove;proto.VERSION="0.5.6";if(this.window){proto.fetch=utils.fetch;root.Syringe=new Syringe}else if(typeof module!=="undefined"&&module.exports){exports=module.exports=new Syringe}}).call(this);
//# sourceMappingURL=syringe.min.map